HDU

来源:互联网 发布:ios10软件闪退 编辑:程序博客网 时间:2024/06/05 12:07

An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress. 


Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed. 


Figure 1


Figure 2
Input
The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them. 
Output
The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 2^63 paths for any board. 
Sample Input
423311213123131104333212131232212051110101111111111110111101-1
Sample Output
307          Brute force methods examining every path will likely exceed the allotted time limit. 64-bit integer values are available as "__int64" values using the Visual C/C++ or "long long" values using GNU C/C++ or "int64" values using Free Pascal compilers. 
Hint
Hint         
            快哭了一开始题都理解错了T T。

题意:从一条路一直走......只能走直线(也不能说走到头了才可以拐弯,就是发现走不完当前步数就要拐弯,地图中的数字就是可走的步数)。0当然不能走啦。向右或向下两种方式。求从左上角走到右下角的方式。

另外结果在2^63内,所以要用long long,

还有= = ! 这道题地图每点的数值没有空格,所以不能%d直接输入,应该用字符型输入,再转化成整形。


参考链接

#include<stdio.h>  #include<string.h>  __int64 dp[50][50];//存步数....貌似题目说数据会很大  char mapp[50][50];  int map[50][50];  int n;  int main()  {      while(~scanf("%d",&n)&&n!=-1)      {          for(int i=0; i<n; i++)              scanf("%s",mapp[i]);          for(int i=0; i<n; i++)              for(int j=0; j<n; j++)                  map[i][j]=mapp[i][j]-'0';          memset(dp,0,sizeof(dp));          dp[0][0]=1;          for(int i=0; i<n; i++)              for(int j=0; j<n; j++)              {                  if(!map[i][j])continue;                  if(i+map[i][j]<n)dp[i+map[i][j]][j]+=dp[i][j];//因为只能走直线,这样就是要用两个if来分别表示横着和竖着走了                  if(j+map[i][j]<n)dp[i][j+map[i][j]]+=dp[i][j];//符合条件的话,当前点的dp要加上走到的那一点的dp;             }          printf("%I64d\n",dp[n-1][n-1]);      }      return 0;  }  


。。刚开始接触动规,还不太懂,慢慢来吧,,,奋斗

原创粉丝点击